SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: 'pacman ghost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'RavasiAronson 5/16/2012 19:30'!
blueGhost

	^ ghost.! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 20:23'!
down

^0@(-1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 20:29'!
ghostHouseDoorType

	^ GhostHouseDoorType new.! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 19:57'!
left

	^-1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 20:33'!
leftTransporterType

	^LeftTransporterType new! !

!PacManTest methodsFor: 'actors' stamp: 'RavasiAronson 5/16/2012 19:29'!
pacman

^ pacman.! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 19:57'!
right

^1@0.! !

!PacManTest methodsFor: 'initializing' stamp: 'RavasiAronson 5/16/2012 20:47'!
setUp 
	"initialize internal collaborators"

	pacman := Pacman new.
	ghost := Ghost new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 20:03'!
spaceType

	^SpaceType new! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'RavasiAronson 5/16/2012 20:24'!
test03GhostMovesIntoSpaces
	
	self
		assert: self blueGhost position + (-1 @ 0)
		equals: (self spaceType nextPositionFor: self blueGhost going: self left).
	self
		assert: self blueGhost position + (1 @ 0)
		equals: (self spaceType nextPositionFor: self blueGhost going: self right).
	self assert: self blueGhost position + (0 @ 1) equals: (self spaceType nextPositionFor: self blueGhost going: self up).
	self
		assert: self blueGhost position + (0 @ -1)
		equals: (self spaceType nextPositionFor: self blueGhost going: self down)! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'RavasiAronson 5/16/2012 20:23'!
up

^0@1.! !

!PacManTest methodsFor: 'construction block types' stamp: 'RavasiAronson 5/16/2012 19:52'!
wallType

	^ WallType new.! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 20:53'!
goIntoHouse: direction
	"moves the actor into the Ghost House"

	self subclassResponsibility.! !

!Actor methodsFor: 'initializing' stamp: 'RavasiAronson 5/16/2012 20:53'!
initialize 

 self subclassResponsibility.! !

!Actor methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 20:52'!
moveTo: direction

	"moves the actor in the position passed as parameter"

	position := (self position)+ direction.
	^self.! !

!Actor methodsFor: 'locating' stamp: 'RavasiAronson 5/16/2012 19:42'!
position
	"returns the actual position"

	^position.
	! !

!Actor methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 20:31'!
transport 
	"comment stating purpose of message"

	self subclassResponsibility.! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 20:41'!
goIntoHouse: direction  
	"comment stating purpose of message"

	self moveTo: direction.
	^self.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 19:41'!
initialize 
	"comment stating purpose of message"

	position := 1@1.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 20:32'!
transport  
	"comment stating purpose of message"

	^self! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 20:37'!
goIntoHouse: direction 
	"comment stating purpose of message"
	^self! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 19:41'!
initialize 
	"comment stating purpose of message"

	position := 2@2.! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/16/2012 20:33'!
transport
	"comment stating purpose of message"

	position := 3@10.
	^self! !

Object subclass: #BlockType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlockType methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 19:49'!
nextPositionFor: actor going: direction 
	"comment stating purpose of message"

	self subclassResponsibility.! !

BlockType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 20:57'!
nextPositionFor: actor going: direction 
	"instructs the actor to move into the ghost house"

	^(actor goIntoHouse: direction) position.! !

BlockType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 20:57'!
nextPositionFor: actor going: direction 
	"instructs the actor to teleport"

	^(actor transport) position ! !

BlockType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 20:57'!
nextPositionFor: actor going: direction 
	"instructs the actor to move into the empty space"

	^(actor moveTo: direction) position.! !

BlockType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'moving' stamp: 'RavasiAronson 5/16/2012 20:58'!
nextPositionFor: actor going: direction
	"the actor can't move into a wall, so returns the same position"

	^ actor position! !
